//<script language="JavaScript">
//<!--

var Oafw = Class.create();
var controlObjs = [];
var activeElement;
var errorElement;
var errorFlag = false;
var dateErrorMessage;
var focusFlag = false;
var clickFlag = false;
var initialFocus=null;
var returnFlag = false;
var errorCount = 0;
var errorClickFlag =false;
var eventType;
var colorMap = new Object();
var altFlag = false;
var initialFlag = false;
var counter = 0;

Oafw.prototype = {
	///////////////////////////////////////////////////////
	//	initialize
	///////////////////////////////////////////////////////
	initialize: function() {
		Event.observe(window, 'load', this.load.bindAsEventListener(this), false);
		Event.observe(window, 'focus', this.setFocusColor.bindAsEventListener(this), false);
		Event.observe(window.document, 'keypress', this.keyPress.bindAsEventListener(this), false);
		Event.observe(window.document, 'keydown', this.moveBox.bindAsEventListener(this), false);
	//	Event.observe(window.document, 'click', this.click.bindAsEventListener(this), false);
	},
	///////////////////////////////////////////////////////
	//	load
	///////////////////////////////////////////////////////
	load: function(event) {
		return load(event);
	},
	
	///////////////////////////////////////////////////////
	//	setFocusColor
	///////////////////////////////////////////////////////
	setFocusColor: function(event) {
		return setFocusColor(event);
	},
	///////////////////////////////////////////////////////
	//	keyPress
	///////////////////////////////////////////////////////
	keyPress: function(event) {
		return keyPress(event);
	},
	
	///////////////////////////////////////////////////////
	//	click
	///////////////////////////////////////////////////////
	click: function(event) {
		return click(event);
	},
	///////////////////////////////////////////////////////
	//	keydown
	///////////////////////////////////////////////////////
	moveBox: function(event) {
		return moveBox(event);
	}

}// end



///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function load(event){

	eventType = "keyDown";
	var j = 0;
	var nodes = document.forms[0].elements ;
	colorMap = new Object();
	var initialElement;
	initialFlag = false;
	
	for (var i = 0; i < nodes.length; i++){
		if( nodes[i].name!=""){
			if (isFocusObjs(nodes[i].type)) {
				controlObjs[j] = nodes[i];
				j++;
			}
		}
		if (isFocusObjs(nodes[i].type) == false) {
			continue;
		}	
		colorMap[nodes[i].name] = nodes[i].style.backgroundColor;
		if(initialFocus == null && initialFlag == false){
			initialElement = nodes[i];
			initialFlag = true;
		}else if(nodes[i].name == initialFocus){
			initialElement = nodes[i];
			initialFlag = true;
		}
		if(nodes[i].value != null && nodes[i].value.length > 0){
			if($(nodes[i]).getAttribute('format') != null){
				var format = $(nodes[i]).getAttribute('format');
				var formatArray = format.split(";");
				
				var r = nodes[i].value;
				var unit = "";
				var decimal = 0;
				if(nodes[i].value.indexOf(".") != -1){
					decimal = nodes[i].value.length - nodes[i].value.indexOf(".") - 1;
				}						
				var formatType
				for (var k = 0; k < formatArray.length; k++){
					formatType = formatArray[k].substring(0,formatArray[k].indexOf("("));
					if(formatType == "money"){
						unit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
					}
					if(formatType == "decimal"){
						decimal = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
					}
				}
				if(r.startsWith(unit)){
					r = r.replace(unit,"");
				}
				if(decimal >= 0){
					r = formatNum(r,decimal);
					nodes[i].value = r;
				}				
				for (var k = 0; k < formatArray.length; k++){
					var formatType = formatArray[k].substring(0,formatArray[k].indexOf("("));
					if(formatType == "comma"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						nodes[i].value = formatNumCnm(r,digit,decimal);
					}
					if(formatType == "fillzero"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						nodes[i].value = formatFillZero(r, digit);
					}
					if(isNumFormat(formatType) == true){
						$(nodes[i]).style.textAlign = "right";
					}
					if(formatType == "date"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						if(DateCheck(nodes[i].value,digit) == false){
							nodes[i].value = r;
						}else{
							nodes[i].value = rDate;
						}
// comment by kita 2010/08/16	$(nodes[i]).style.textAlign = "center";
					}
				}
				if(unit.length > 0){
					nodes[i].value = unit + "" + nodes[i].value;
					$(nodes[i]).style.textAlign = "right";					
				}			
			}
		}
	}

	
	var fcolor = focusColor;
	var bcolor = normalBgColor;

	len = document.forms[0].elements.length;
	for(i = 0; i < len; i++) {
		document.forms[0].elements[i].onfocus = initial_focused;
		document.forms[0].elements[i].onblur = initial_blured;
	}
	
	if(eventType != "keyDown" && eventType != "click" ){
		activeElement.blur();
		activeElement.focus();
		if(errorClickFlag == true){
			Field.activate(activeElement);
			activeElement.style.backgroundColor = focusColor;
			errorClickFlag = false;	
			Event.stop(event);
			return false;
		}				
	}
	
	
	if(getType(initialElement)=="radio" || getType(initialElement)=="checkbox"){
		var objs = getObjs(initialElement.name);
		// ͎Ԃ̂Ő擪IDɃtH[JX
		if(objs.length > 1){

			objs[0].checked = true;
			objs[0].focus();
			objs[0].style.backgroundColor = fcolor;
			
		}
		
/*****************  
		for (var k = 0;k < objs.length;k++) {
	
			if(objs[k].disabled == false ){
				if(initialElement.type=="radio"){
					objs[k].checked = true;
				}
			//	document.all(initialElement.name).selectIndex = k;
				objs[k].focus();
				objs[k].style.backgroundColor = fcolor;
			}
		}
******************/
	}else if(getType(initialElement) == "select-one"){
		if(navigator.userAgent.match("MSIE")){
			// IEł̓ZNg{bNXdocument.all(activeElement.name).select()G[							
		}else{
			document.all(activeElement.name).select();
		}			
		document.all(initialElement.name).focus();
	}else if(getType(initialElement) == "submit"){
		if(navigator.userAgent.match("MSIE")){
			// IEł̓Tu~bgdocument.all(activeElement.name).select()G[							
		}else{
			document.all(activeElement.name).select();
		}			
		document.all(initialElement.name).focus();				
	}else{	
		if(getType(initialElement)!=""){
			document.all(getName(initialElement)).focus();
			document.all(getName(initialElement)).select();
		}
	}
	eventType = "load";	

	return true;
}

function getObjs(initialFocus){

	var j=0;
	var objs=[];
	var element = document.forms[0].elements;
	var len = document.forms[0].elements.length;
	for(i = 0; i < element.length; i++) {
	
		if(element[i].name == initialFocus){
			objs[j] = element[i];
			j++;
		}
	}
	return objs;
}

function getName(obj){

	if(getType(obj)!=""){
		if(obj.name != null && obj.name != "undefined"){//
			return obj.name;
		} 
	}
	return "";
}

function getType(obj){

	if(obj.type != null && obj.type != "undefined"){//
		return obj.type;
	} 
	return "";
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function setFocusColor(event){

	if(navigator.userAgent.match("Firefox")){
		if(errorClickFlag == true){
			errorClickFlag = false;	
			alertError(activeElement,detailMsg,false);
			Event.stop(event);
			return false
		}
	}
	return true;
}
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function keyPress(event){
	eventType = "keyPress";
	var returnObj = activeElement;
	activeElement = Event.element(event);
	var key = event.keyCode;
	keyCode = key;
	if(keyCode != key_down && keyCode != key_left && keyCode != key_up && keyCode != key_right){
		if(keyCode == 13 && returnObj.type != "textarea"){
			eventType = "keyDown";
			if(returnCtrl(activeElement)){
				Event.stop(event);
				return false;
			}
		}
		if(focusFlag){
	//		Field.activate($(activeElement));
			focusFlag = false;
			$(activeElement).onfocus;
		}
	}
	return true;
}	

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function click(event){

	eventType = "click";
	errorCount = 0;
	clickFlag = false;
	var returnObj = activeElement;// 

	if(errorFlag==true){
		Event.stop(event);
		return false;
	}

	var clickElement = Event.element(event);
	var type = clickElement.type;
	
	if(clickElement != returnObj){

		setUnFocus(returnObj);
		setFocus(returnObj);
		if(errorClickFlag == true){
			Field.activate(returnObj);
			setFocusColor(returnObj, focusColor);
			errorClickFlag = false;	
			Event.stop(event);
			return false;
		}
	
		if(clickElement != null && clickElement != "undefined" &&
			clickElement.disabled != true && clickElement.readOnly != true) {
			setUnFocus(clickElement);
			setFocus(clickElement);
		}		
	}
	

	if (clickElement.disabled == true || clickElement.readOnly == true) {
		Field.activate(returnObj);
		setFocusColor(returnObj, focusColor);
		return false;
	}	
	if (isFocusObjs(getType(clickElement)) == false) {
		if(isFocusObjs(getType(returnObj)) == true){
			Field.activate(returnObj);
			setFocusColor(returnObj, focusColor);
			return false;
		}
	}	
	
	if(type=="radio" || type=="checkbox"){
		
		for (var k = 0;k < document.all(activeElement.name).length;k++) {
			
			if(document.all(clickElement.name)[k].checked){
				activeElement = clickElement;
				clickFlag = true;
				Field.activate(activeElement);
				activeElement.style.backgroundColor = focusColor;
				clickFlag = false;
				return true;
			}
		}	
		return true;
	}
	
	return true;
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function moveBox(event){

	eventType = "keyDown";
	errorCount = 0;
	activeElement = Event.element(event);
	var key = event.keyCode;
	keyCode = key;

	
	if(keyCode == key_alt){
		altFlag = true;
	}
	
	if((keyCode == key_down || keyCode == key_left || keyCode == key_up || keyCode == key_right || keyCode == key_tab) && altFlag == false){
		activeElement.blur();
		activeElement.focus();
		if(errorClickFlag == true){
			Field.activate(activeElement);
			activeElement.style.backgroundColor = focusColor;
			errorClickFlag = false;	
			Event.stop(event);
			return false;
		}	
	}		
	
	var name = activeElement.name;
	var nodes = document.forms[0].elements ;
	var nameNum = $(activeElement).getAttribute('cursor');
	
	if(keyCode == key_down){

		var cursorNum;
		var map = new Object();
		var typeMap = new Object();
		var j = 0;
		var value;
		var minNum = 0;
		for (var i = 0; i < nodes.length; i++){
			if( nodes[i].name==""){
				continue;
			}
			if (isFocusObjs(nodes[i].type) == false) {
				continue;
			}
			if (nodes[i].disabled == true || nodes[i].readOnly == true) {
				continue;
			}
			if(nodes[i].name==activeElement.name && nodes[i]==activeElement){
				j = i;
			}
			cursorNum =$(nodes[i]).getAttribute('cursor');
			if(cursorNum == null){
				continue;
			}
			var base = cursorNum;
//				var counter = 0;
			counter = 0;
			var m;
			value = nodes[i];
			if(eval(minNum) < eval(base)){
				minNum = base;
			}
	//		typeMap = createFocusMap(true, nodes[i],map,base,cursorNum,counter,value);
			if(nodes[i].type == "select-one"){
				for (var k = 0;k < document.all(nodes[i].name).length;k++) {

					value = document.all(nodes[i].name)[k];
					map = createMap(map, base, cursorNum, counter, value);
					typeMap = createMap(typeMap, base, cursorNum, counter, nodes[i]);

				}
			}else{
				map = createMap(map, base, cursorNum, counter, value);
				typeMap = createMap(typeMap, base, cursorNum, counter, nodes[i]);

			}
		}
		var maxNum = minNum;
		var firstNum = maxNum;
		var valueStr = "";
//			for(var m in map){
//				valueStr += m + " and " + map[m].name + " and " + map[m].value + "\r\n";
//			}
//			alert(valueStr);

		var numMap = new Object();
		var counter = 0;
		for(var i = 0; i <= maxNum ; i++){
			for(var m in map){
				var baseNum = m.substring(0,m.indexOf("_"));
				if(baseNum.length == 0){
					baseNum = m;
				}
				if(i == baseNum){
					numMap[counter] = map[m];
					counter++;
				}
			}
		}
		
		var typeNumMap = new Object();
		var counter = 0;
		for(var i = 0; i <= maxNum ; i++){
			for(var m in typeMap){
				var baseNum = m.substring(0,m.indexOf("_"));
				if(baseNum.length == 0){
					baseNum = m;
				}
				if(i == baseNum){
					typeNumMap[counter] = typeMap[m];
					counter++;
				}
			}
		}			
//			var valueStr = "";
//			for(var m in numMap){
//				valueStr += m + " and " + numMap[m].name + " and " + numMap[m].value + "\r\n";
//			}
//			alert(valueStr);
//			var valueStr = "";
//			for(var m in typeMap){
//				valueStr += m + " and " + typeMap[m].name + " and " + typeMap[m].value + "\r\n";
//			}
//			alert(valueStr);
		for(var m in numMap){
			var baseNum = m.substring(0,m.indexOf("_"));
			if(baseNum.length == 0){
				baseNum = m;
			}
			if(eval(firstNum) > eval(baseNum)){
				firstNum = baseNum;
				firstObj = numMap[m];
			}
			for (var k = 0; k < nodes.length; k++){
				if( nodes[k].name==""){
					continue;
				}
				if (isFocusObjs(nodes[k].type) == false) {
					continue;
				}
				if (nodes[k].disabled == true || nodes[k].readOnly == true) {
					continue;
				}
				if(nodes[k] == numMap[m] && nodes[k] == activeElement){
					var rNum = eval(m) + 1
					if(rNum == counter){
						if(numMap[0].type == "radio"){
							numMap[0].checked = true;
							Field.activate($(numMap[0]));
							Event.stop(event);
							return true;
						
						}else if(typeNumMap[0].type == "select-one"){
							numMap[0].checked = true;
							Field.activate($(typeNumMap[0]));
							Event.stop(event);
							return true;					
						}	
						Field.activate($(numMap[0]));
						return true;												
					//	right();
					//	return true;
					}
					if(numMap[rNum].type == "radio"){
						numMap[rNum].checked = true;
						Field.activate($(numMap[rNum]));
						Event.stop(event);
						return true;
					
					}else if(typeNumMap[rNum].type == "select-one"){
						numMap[rNum].checked = true;
						Field.activate($(typeNumMap[rNum]));
						Event.stop(event);
						return true;					
					}
					Field.activate($(numMap[rNum]));
					return true;
				}else if(nodes[k].type == "select-one" && nodes[k] == activeElement){
					for (var n = 0;n < document.all(nodes[k].name).length;n++) {
						if(document.all(nodes[k].name)[n] == numMap[m] && document.all(nodes[k].name)[n].selected == true){
							if(n == eval(document.all(nodes[k].name).length - 1)){
								var rNum = eval(m) + 1;
								if(rNum == counter){
									if(numMap[0].type == "radio"){
										numMap[0].checked = true;
										Field.activate($(numMap[0]));
										Event.stop(event);
										return true;
									}else if(typeNumMap[0].type == "select-one"){
										numMap[0].checked = true;
										Field.activate($(typeNumMap[0]));
										Event.stop(event);
										return true;					
									}	
									Field.activate($(numMap[0]));
									return true;										
								}									
								numMap[rNum].checked = true;
								numMap[rNum].focus();								
								Field.activate($(typeNumMap[rNum]));
							}else{
								document.all(nodes[k].name)[n + 1].checked = true;
								document.all(nodes[k].name)[n + 1].focus();
								Field.activate(document.all(nodes[k].name)[n + 1]);
								return true;
							}								
							Event.stop(event);
							return true;		
						}
					}
				}
			}
		}
		right();
		return false;
	}
	
	if(keyCode == key_up){
	  	var cursorNum;
	  	var typeMap = new Object();
	  	var map = new Object();
	  	var j = 0;
	  	var value;
	  	var minNum = 1;

		for (var i = nodes.length - 1; i >= 0; i--){
			if( nodes[i].name==""){
				continue;
			}
			if (isFocusObjs(nodes[i].type) == false) {
				continue;
			}
			if (nodes[i].disabled == true || nodes[i].readOnly == true) {
				continue;
			}
			if(nodes[i].name==activeElement.name && nodes[i]==activeElement){
				j = i;
			}
			cursorNum =$(nodes[i]).getAttribute('cursor');
			if(cursorNum == null){
				continue;
			}
			var base = cursorNum;
//				var counter = 0;
			counter = 0;
			var m;
			value = nodes[i];
			if(eval(minNum) < eval(base)){
				minNum = base;
			}				

//			typeMap = createFocusMap(false, nodes[i], map,base,cursorNum,counter,value);
			
			if(nodes[i].type == "select-one"){
				for (var k = document.all(nodes[i].name).length - 1;k >= 0;k--) {

					value = document.all(nodes[i].name)[k];
					map = createMap(map, base, cursorNum, counter, value);
					typeMap = createMap(typeMap, base, cursorNum, counter, nodes[i]);

				}
			}else{
				map = createMap(map, base, cursorNum, counter, value);
				typeMap = createMap(typeMap, base, cursorNum, counter, nodes[i]);

			}

		}
		var maxNum = minNum;
		var firstNum = maxNum;

		var numMap = new Object();
		var counter = 0;
		for(var i = maxNum; i >= 0 ; i--){
			for(var m in map){
				var baseNum = m.substring(0,m.indexOf("_"));
				if(baseNum.length == 0){
					baseNum = m;
				}
				if(i == baseNum){
					numMap[counter] = map[m];
					counter++;
				}
			}
		}
		
		var typeNumMap = new Object();
		var counter = 0;
		for(var i = maxNum; i >= 0 ; i--){
			for(var m in typeMap){
				var baseNum = m.substring(0,m.indexOf("_"));
				if(baseNum.length == 0){
					baseNum = m;
				}
				if(i == baseNum){
					typeNumMap[counter] = typeMap[m];
					counter++;
				}
			}
		}			

//			var valueStr = "";
//			for(var m in numMap){
//				valueStr += m + " and " + numMap[m].name + " and " + numMap[m].value + "\r\n";
//			}
//			alert(valueStr);
//			var valueStr = "";
//			for(var m in typeMap){
//				valueStr += m + " and " + typeMap[m].name + " and " + typeMap[m].value + "\r\n";
//			}
//			alert(valueStr);

		for(var m in numMap){
			var baseNum = m.substring(0,m.indexOf("_"));
			if(baseNum.length == 0){
				baseNum = m;
			}
			if(eval(firstNum) > eval(baseNum)){
				firstNum = baseNum;
				firstObj = numMap[m];
			}
			for (var k = 0; k < nodes.length; k++){
				if( nodes[k].name==""){
					continue;
				}
				if (isFocusObjs(nodes[k].type) == false) {
					continue;
				}
				if (nodes[k].disabled == true || nodes[k].readOnly == true) {
					continue;
				}
				if(nodes[k] == numMap[m] && nodes[k] == activeElement){
					var rNum = eval(m) + 1
					if(rNum == counter){
						if(numMap[0].type == "radio"){
							numMap[0].checked = true;
							Field.activate($(numMap[0]));
							Event.stop(event);
							return true;
						
						}else if(typeNumMap[0].type == "select-one"){
							numMap[0].checked = true;
							Field.activate($(typeNumMap[0]));
							Event.stop(event);
							return true;					
						}	
						Field.activate($(numMap[0]));
						return true;														
					//	left();
					//	return true;
					}
					if(numMap[rNum].type == "radio"){
						numMap[rNum].checked = true;
						Field.activate($(numMap[rNum]));
						Event.stop(event);
						return true;
					
					}else if(typeNumMap[rNum].type == "select-one"){
						numMap[rNum].checked = true;
						Field.activate($(typeNumMap[rNum]));
						Event.stop(event);
						return true;					
					}
					Field.activate($(numMap[rNum]));
					return true;
				}else if(nodes[k].type == "select-one" && nodes[k] == activeElement){
					for (var n = 0;n < document.all(nodes[k].name).length;n++) {
						if(document.all(nodes[k].name)[n] == numMap[m] && document.all(nodes[k].name)[n].selected == true){
							if(n == 0){
								var rNum = eval(m) + 1
								if(rNum == counter){
									if(numMap[0].type == "radio"){
										numMap[0].checked = true;
										Field.activate($(numMap[0]));
										Event.stop(event);
										return true;
									
									}else if(typeNumMap[0].type == "select-one"){
										numMap[0].checked = true;
										Field.activate($(typeNumMap[0]));
										Event.stop(event);
										return true;					
									}	
									Field.activate($(numMap[0]));
									return true;																	
								//	left();
								//	return true;
								}									
								numMap[rNum].checked = true;
								numMap[rNum].focus();								
								Field.activate($(typeNumMap[rNum]));
							}else{
								document.all(nodes[k].name)[n - 1].checked = true;
								document.all(nodes[k].name)[n - 1].focus();
								Field.activate(document.all(nodes[k].name)[n - 1]);
								return true;
							}								
							Event.stop(event);
							return true;		
						}
					}
				}
			}
		}
		left();
		return false;						
	}

	if(keyCode == key_right){
		right();
	}
	
	if(keyCode == key_left){
		left();
	}
	return true;	
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function right(){

  	var map = new Object();
  	var j = 0;
  	var value;
	var counter = 0;
	var nodes = document.forms[0].elements ;
	
	for (var i = 0; i < nodes.length; i++){
		if( nodes[i].name==""){
			continue;
		}
		if (isFocusObjs(nodes[i].type) == false) {
			continue;
		}
		if (nodes[i].disabled == true || nodes[i].readOnly == true) {
			continue;
		}
		if(nodes[i].name==activeElement.name && nodes[i]==activeElement){
			j = i;
		}
		value = nodes[i];

		if(nodes[i].type == "select-one"){
			for (var k = 0;k < document.all(nodes[i].name).length;k++) {
				value = document.all(nodes[i].name)[k];
				map[counter] = value;
				counter += 1;
			}
		}else{
			map[counter] = value;	
			counter += 1;			
		}
	}
	for(var m in map){
		for (var k = 0; k < nodes.length; k++){
			if( nodes[k].name==""){
				continue;
			}
			if (isFocusObjs(nodes[k].type) == false) {
				continue;
			}
			if (nodes[k].disabled == true || nodes[k].readOnly == true) {
				continue;
			}

			if(k > j){
				if(nodes[k].type == "select-one"){
					for (var n = 0;n < document.all(nodes[k].name).length;n++) {
						if(document.all(nodes[k].name)[n] == map[m] && document.all(nodes[k].name)[n].selected == true){
							Field.activate(nodes[k]);
							return true;
						}
					}							
				}else{
					if(nodes[k].name == map[m].name && nodes[k] == map[m]){
						if(activeElement.type == "select-one"){
							for (var l = 0;l < document.all(activeElement.name).length;l++) {
								if(document.all(activeElement.name)[l].selected == true){
									document.all(activeElement.name)[l].checked = true;	
								}
							}
						}
						if(nodes[k].type == "radio"){
							map[m].checked = true;
							map[m].focus();
							Field.activate(map[m]);
							Event.stop(event);
							return true;
						}
						Field.activate(map[m]);
						Event.stop(event);
						return true;
					}
				}
			}
		}
	}
	if(map[0].type == "radio"){
		map[0].checked = true;
	}			
	map[0].focus();
	Field.activate(map[0]);
	Event.stop(event);			

	return false;						
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function left(){
  	var map = new Object();
  	var j = 0;
  	var value;
  	var counter = 0;
	var nodes = document.forms[0].elements ;
	for (var i = nodes.length - 1; i >= 0; i--){
		if( nodes[i].name==""){
			continue;
		}
		if (isFocusObjs(nodes[i].type) == false) {
			continue;
		}
		if (nodes[i].disabled == true || nodes[i].readOnly == true) {
			continue;
		}
		if(nodes[i].name==activeElement.name && nodes[i]==activeElement){
			j = i;
		}
		value = nodes[i];

		if(nodes[i].type == "select-one"){
			for (var k = document.all(nodes[i].name).length - 1;k >= 0;k--) {
				value = document.all(nodes[i].name)[k];
				map[counter] = value;
				counter += 1;
			}
		}else{
			map[counter] = value;	
			counter += 1;			
		}
	}

	for(var m in map){
		for (var k = nodes.length - 1; k >= 0; k--){
			if( nodes[k].name==""){
				continue;
			}
			if (isFocusObjs(nodes[k].type) == false) {
				continue;
			}
			if (nodes[k].disabled == true || nodes[k].readOnly == true) {
				continue;
			}

			if(k < j){
				if(nodes[k].type == "select-one"){
					for (var n = document.all(nodes[k].name).length - 1;n >= 0;n--) {
						if(document.all(nodes[k].name)[n] == map[m] && document.all(nodes[k].name)[n].selected == true){
							Field.activate(nodes[k]);
				//			if(navigator.userAgent.indexOf("Firefox") != -1){ 
				//				document.all(nodes[k].name).selectedIndex = n + 1;
				//			}									
							return true;
						}
					}							
				}else{
					if(nodes[k].name == map[m].name && nodes[k] == map[m]){
						if(activeElement.type == "select-one"){
							for (var l = 0;l < document.all(activeElement.name).length;l++) {
								if(document.all(activeElement.name)[l].selected == true){
									document.all(activeElement.name)[l].checked = true;	
								}
							}
						}							
						if(nodes[k].type == "radio"){
							map[m].checked = true;
							map[m].focus();
							Field.activate(map[m]);
							Event.stop(event);
							return true;
						}	
						Field.activate(map[m]);
						Event.stop(event);
						return true;
					}
				}
			}
		}
	}
	moveCursol("PgUp", activeElement);
	return false;								

}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function initial_focused() {
  	var fcolor = focusColor;

	if(clickFlag == false){
		activeElement = this;
		if(errorFlag == true){
			if(errorElement == null){
				return false;
			}
			activeElement = errorElement;
		}

		var type = activeElement.type;
		var checkboxFlag = false;
		if(type=="radio" || type=="checkbox"){
		
			var objs = getObjs(activeElement.name);
			for (var k = 0;k < objs.length;k++) {
				if(checkboxFlag == false && type == "checkbox"){
					activeElement.style.backgroundColor = fcolor;
					break;
				}
				if(returnFlag == false){
					activeElement.style.backgroundColor = fcolor;
					break;
				}	
				if(objs[k].checked){
				//	document.all(activeElement.name)[k].checked = true;
				//	document.all(activeElement.name).selectIndex = k;
					objs[k].focus();
					activeElement.style.backgroundColor = fcolor;
				}
			}
		}else if(altFlag == true && activeElement.type == "select-one"){
			document.all(activeElement.name).select();
			document.all(activeElement.name).focus();
			activeElement.style.backgroundColor = fcolor;					
			altFlag = false;
			return true;						
		}else{	
			if(activeElement.type == "text"){
				$(activeElement).style.textAlign = "left";
			}
			if(activeElement.value != null && activeElement.value.length > 0){
				if($(activeElement).getAttribute('format') != null){
					var format = $(activeElement).getAttribute('format');
					var formatArray = format.split(";");
					var r = activeElement.value;
					var unit = "";
					var decimal = 0;
					if(this.value.indexOf(".") != -1){
						decimal = activeElement.value.length - activeElement.value.indexOf(".") - 1;
					}
					var formatType;
					for (var k = 0; k < formatArray.length; k++){
						formatType = formatArray[k].substring(0,formatArray[k].indexOf("("));
						if(formatType == "comma"){
							r = r.replace(/,/g,"");
						}						
						if(formatType == "money"){
							unit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
							r = r.replace(unit,"");
						}
					}
					activeElement.value = r;
				}
			}	
			
			if(navigator.userAgent.match("MSIE") && (activeElement.type == "select-one" || activeElement.type == "submit")){
				// IEł̓ZNg{bNXATu~bgdocument.all(activeElement.name).select()G[							
			}else{
				document.all(activeElement.name).select();
			}
			document.all(activeElement.name).focus();
			activeElement.style.backgroundColor = fcolor;						
		}
		if(this.name != activeElement.name){
			focusFlag = true; 
			return false;
		}				
	}
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function initial_blured() {
//	activeElement = Event.element(event);
	this.style.backgroundColor = colorMap[this.name];
	var detailMsg = ""; 			  
	errorFlag = false;			  
	var numFlag = false;
	dateErrorMessage = "";
	if(this.value != null && this.value.length > 0){
		if($(this).getAttribute('format') != null){
			var format = $(this).getAttribute('format');
			var formatArray = format.split(";");
			var r = this.value;
			var unit = "";
			var decimal = 0;
			if(this.value.indexOf(".") != -1){
				decimal = this.value.length - this.value.indexOf(".") - 1;
			}
			
			var formatType;
			for (var k = 0; k < formatArray.length; k++){
				formatType = formatArray[k].substring(0,formatArray[k].indexOf("("));
				if(numFlag == false){
					numFlag = isNumFormat(formatType);
				}
				if(formatType == "money"){
					unit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
				}
				if(formatType == "comma"){// add kita
				
					if(formatArray.length == 1 && decimal > 0){
						errorFlag = true;
						detailMsg += ("gpłȂ͂܂");
					}
				
				}						
				if(formatType == "decimal"){
					decimal = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
				}						
				if(formatType == "range"){	
					var digitFrom = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(","));
					var digitTo = formatArray[k].substring(formatArray[k].indexOf(",") + 1,formatArray[k].indexOf(")"));
					if(r.length < digitFrom || r.length > digitTo){						
						errorFlag = true;
						detailMsg += (digitFrom + "ȏ" + digitTo + "ȉœ͂Ă");
					}
				}		
			}
			if(r.startsWith(unit)){
				r = r.replace(unit,"");
			}
			
			if(isNum(r) == false && numFlag == true && errorFlag == false){
				errorFlag = true;
				detailMsg += "pœ͂Ă";
				$(this).style.textAlign = "right";	
			}
			if(decimal >= 0){
				r = formatNum(r,decimal);
				this.value = r;
			}				
			if(errorFlag == false){
				for (var k = 0; k < formatArray.length; k++){
					formatType = formatArray[k].substring(0,formatArray[k].indexOf("("));
					if(formatType == "number"){
						this.value = r;
						$(this).style.textAlign = "right";
					}
					if(formatType == "decimal"){
						$(this).style.textAlign = "right";
					}							
					if(formatType == "comma"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						r = formatNumCnm(r, digit,decimal);
						this.value = r;
						$(this).style.textAlign = "right";			
					}
					if(formatType == "fillzero"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						r = formatFillZero(r, digit);
						this.value = r;
//						$(this).style.textAlign = "right";			
					}
					if(formatType == "date"){
						var digit = formatArray[k].substring(formatArray[k].indexOf("(") + 1,formatArray[k].indexOf(")"));
						if(DateCheck(r,digit) == false){
							detailMsg += dateErrorMessage;
							errorFlag = true;
						}else{
							this.value = rDate;
						}
// comment by kita 2010/08/16		$(this).style.textAlign = "center";
					}							
				}
				if(unit.length > 0){
					r = unit + "" + r;
					this.value = r;
					$(this).style.textAlign = "right";					
				}			
			}
		}
		
		if (errorFlag == true && this.name == activeElement.name) {
			if(errorCount == 0 && eventType == "keyDown" ){
				errorElement = activeElement;
				errorClickFlag = true;
				document.all(errorElement.name).select();
				document.all(errorElement.name).focus();	
				alertError(errorElement,detailMsg,true);	
				return false																
			}
			var eventObj = Event.element(event);
			if(eventType != "keyDown" && eventType != "click" ){
				activeElement.blur();
				activeElement.focus();
				if(errorClickFlag == true){
					alertError(activeElement,detailMsg,false);
					Event.stop(event);
					return false								
				}
			}else if(eventObj == null){
				activeElement.blur();
				activeElement.focus();
				if(errorClickFlag == true){
					errorClickFlag = false;	
					alertError(activeElement,detailMsg,true);
					Event.stop(event);
					return false								
				}
			}
			if(errorClickFlag == true){
				activeElement.blur();
				activeElement.focus();
				errorClickFlag = false;	
				alertError(activeElement,detailMsg,false);
				Event.stop(event);
				return false
			}							
							
			errorElement = activeElement;
			errorClickFlag = true;
			document.all(errorElement.name).select();
			document.all(errorElement.name).focus();
			alertError(errorElement,detailMsg,true);
			return false											
		} 		
	}
}// function end 


var debug = false;
var idx = 0;
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function log(msg) {
	if(debug == true){
		var objs = document.getElementsByName ('dbg');
		objs[0].value = idx+" "+msg+"\n" + objs[0].value ;
		idx++;
	}
}
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function isNum( str ){
	var	i, l, Err, cnmCnt, d ;
	
	bErr	= false ;
	cnmCnt	= 0 ;
	l	= str.length ;
	var firstNum = 0;
	var firstFlag = false;
	var lastNum = l - 1;
	var cnmNum;
	for( i=0;i<l;i++){
		d	= str.substr(i,1) ;
		if( d >= "0" && d <="9" ){
			if(firstFlag == false){
				firstNum = i;
				firstFlag = true;
			}
			lastNum = i;
		}else if( d =="-" ){
			if( i!=0 ){
				bErr	= true ;
				break ;
			}
		}else if( d == "." ){
			cnmCnt	= cnmCnt + 1 ;
			if( cnmCnt > 1 ){
				bErr	= true ;
				break ;
			}
			cnmNum = i;
		}else if( d == "," ){
		}else{
			bErr	= true ;
			break ;
		}
	}
	if(firstNum >= cnmNum || lastNum <= cnmNum){
		bErr	= true ;
	}
	return	!bErr ;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function getSeisuu( str ){
	var	i, j, l, d, r, bPls ;		

	bPls	= true ;
	r	= "" ;
	l	= str.length ;
	for( i=0;i<l;i++){
		d	= str.substr(i,1) ;
		if( d == "." )	break ;
		if( d >= "0" && d <="9" ){
			r	= "" + r + d ; 
		}else if( d == "-" ){
			bPls	= false ;
		}
	}

	//
	l	= r.length ;
	j	= -1 ;
	for(i=0;i<l;i++){
		if( r.substr(i,1) == "0" ){
			j	= i ;
		}else{
			break ;
		}
	}
	if( j >= 0 )	r	= r.substr(j+1,l-j-1) ;
	if( r == "" )	r	= "0" ;
	if( bPls == false ){
		r	= "-" + r ;
	}
	return	r ;
}


///////////////////////////////////////////////////////
//	w̌Œ菬_ʒutH[}bgɕҏW
///////////////////////////////////////////////////////
function formatNum( numStr, syousuuKeta ){
	var	r, l, i, bPls ;

	r	= "" ;
	if( numStr == null )	return	r ;
	if( numStr == "" )	return	r ;
	
	if( isNum(numStr) == false )	return	numStr ;

	bPls	= true ;
	r	= getSeisuu( numStr ) ;
	if( r.substr(0,1) == "-" ){
		bPls	= false ;
		r	= r.substr(1,r.length-1) ;
	}
	if( syousuuKeta > 0 ){
		r	= r + "." + getSyousuu(numStr, syousuuKeta) ;
	}

	if( bPls == false ){
		r	= "-" + r ;
	}

	return r ;
}

///////////////////////////////////////////////////////
//	菭o
///////////////////////////////////////////////////////
function getSyousuu( str, len )
{
	var wkary,wkstr;
	if( len == 0 )	return "";	// _ȉ̌0̏ꍇ͐؂̂ĂĂ
	wkary = str.split(".")
	// _Ȃ܂2ȏH
	if( wkary.length == 1 || wkary.length > 2 )
		wkstr = "";
	else
		wkstr = wkary[1];
	if( wkstr.length > len )
	{
//	2010/08/16 comment by kita	wkstr = wkstr.substr( 0,len ) + "." + wkstr.substr( len );
//	2010/08/16 comment by kita	wkstr = String( Math.round( Number(wkstr) ) );	// ľܓ
		wkstr = wkstr.substr( 0,len ) ;
	}
	else
	{
		wklen = len - wkstr.length;
		for(ii=0;ii<wklen;ii++)	wkstr = wkstr + "0";
	}
	return wkstr;
}
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function formatNumCnm( numStr, digit, syousuuKeta){
	var	r, l, i, bPls, c ;
	var	seisuu ;		

	r	= "" ;
	if( numStr == null )	return	r ;
	if( numStr == "" )	return	r ;
	
	if( digit == null )	return	numStr ;
	if( digit == "" )	return	numStr ;
	if( isNum(digit) == false )	return	numStr ;
	if(digit < 1)	return	numStr ;
	if( numStr.substr(0,1) == "-" ){
		if( isNum(numStr.substr(1,numStr.length-1)) == false )	return	numStr ;
	}else{
		if( isNum(numStr) == false )	return	numStr ;
	}

	bPls	= true ;
	seisuu	= getSeisuu( numStr ) ;
	if( seisuu.substr(0,1) == "-" ){
		bPls	= false ;
		seisuu	= seisuu.substr(1,seisuu.length-1) ;
	}
	
	l	= seisuu.length ;
	c	= 0 ;		
	for(i=l-1;i>=0;i--){
		r	= seisuu.substr(i,1) + r ;
		c	= c + 1 ;
		if( c >= digit && i > 0 ){
			r	= "," + r ;
			c	= 0 ;
		}
	}
	if( syousuuKeta > 0 ){
		r	= r + "." + getSyousuu(numStr, syousuuKeta) ;
	}
//	alert(syousuuKeta);

	if( bPls == false ){
		r	= "-" + r ;
	}

	return r ;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function formatFillZero(numStr, digit ){
	var r = "";
	var zero = "";
	if( numStr == null )	return	r ;
	if( numStr == "" )	return	r ;
	
	if( digit == null )	return	numStr ;
	if( digit == "" )	return	numStr ;
	if( isNum(digit) == false )	return	numStr ;
	if(digit < 1)	return	numStr ;
	if( numStr.substr(0,1) == "-" ){
		if( isNum(numStr.substr(1,numStr.length-1)) == false )	return	numStr ;
	}else{
		if( isNum(numStr) == false )	return	numStr ;
	}
	var bPls	= true ;
	seisuu	= getSeisuu( numStr ) ;
	if( seisuu.substr(0,1) == "-" ){
		bPls	= false ;
		seisuu	= seisuu.substr(1,seisuu.length-1) ;
	}
	for(i = 0; i < digit;i++){
		zero += "0";
	}
	r = (zero + seisuu).slice(-digit)
			if( bPls == false ){
		r	= "-" + r ;
	}
	return r;
}
	
var focusColor="#88ff88";			//
var normalBgColor="#ffffff";	//
var focusObj=null;
var keyCode=null;
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function isElementType(obj) {

	switch( obj.type ){
	case	"button":
	case	"checkbox":
	case	"file":
	case	"password":
	case	"radio":
	case	"text":
	case	"textarea":
	case	"submit":
	case	"select-one":
	case	"option":
		return true;
	};
	return false;
}

function getType(obj){

	if(obj != null && obj != "undefined"){// 'undefined' 
		return obj.type;
	}
	return "";
}

function setFocus(obj) {

	if(obj != null && obj != "undefined"){//
		if(isElementType(obj)){
			obj.focus();
		}
	}
	return true;
}

function setUnFocus(obj) {

	if(obj != null && obj != "undefined"){// 'undefined' 
		if(isElementType(obj)){
			obj.blur();
		}
	}
}

function setFocusColor(obj, focusColor) {

	if(obj != null && obj != "undefined" && 
		obj.style != null && obj.style != "undefined"){// 
		obj.style.backgroundColor = focusColor;
	}
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function isReturnObjs(objType) {
	log("isReturnObjs="+ objType);
 	switch( objType ){
	case	"text":
	case	"textarea":
	case	"password":
	case	"checkbox":
	case	"select-one":
	case	"radio":
	case	"file":
	case	"button":
	case	"submit":
		return true;
	};
	return false;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function onFocusChange(obj){

	setFocus(obj);
	return true;
}	
	
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function moveFocus(obj) {
	if( obj.name!=""){
		if(	isReturnObjs(obj.type)){
			return onFocusChange(obj);
		}
	}
	return false;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function returnCtrl(activeElement) {

	if(isReturnObjs(activeElement.type)==false){
		return false;
	}
	var nodes = document.forms[0].elements ;
	for (var i = 0; i < nodes.length; i++){
		if(nodes[i].name==""){
			continue;
		}
		if (isFocusObjs(nodes[i].type) == false) {
			continue;
		}		
		if (nodes[i].disabled == true || nodes[i].readOnly == true) {
			continue;
		}
		if(nodes[i].name==activeElement.name && nodes[i]==activeElement){
			for (var j = i+1; j < nodes.length; j++){
				if(nodes[j].name==""){
					continue;
				}
				if (isFocusObjs(nodes[j].type) == false) {
					continue;
				}				
				if (nodes[j].disabled == true || nodes[j].readOnly == true) {
					continue;
				}
				/*
				if(nodes[j].type == "radio"){
					for (var n = 0;n < document.all(nodes[j].name).length;n++) {
						if(document.all(nodes[j].name)[n].checked == true){
							if(n == eval(document.all(nodes[j].name).length - 1)){
								if( moveFocus(nodes[j])==true){
									return true;
								}								
							}else{
								returnFlag = true;
								document.all(nodes[j].name)[n + 1].select();
								document.all(nodes[j].name)[n + 1].focus();
								returnFlag = false;
								Event.stop(event);
								return true;
							}	
						}else{
							if( moveFocus(nodes[j])==true){
								return true;
							}						
						}
					}
				}	
				*/
				if( moveFocus(nodes[j])==true){
					return true;
				}
			}
			for (var j = 0; j < nodes.length; j++){
				if(nodes[j].name==""){
					continue;
				}
				if (isFocusObjs(nodes[j].type) == false) {
					continue;
				}				
				if (nodes[j].disabled == true || nodes[j].readOnly == true) {
					continue;
				}
				/*
				if(nodes[j].type == "radio"){
					for (var n = 0;n < document.all(nodes[j].name).length;n++) {
						if(document.all(nodes[j].name)[n].checked == true){
							if(n == eval(document.all(nodes[j].name).length - 1)){
								if( moveFocus(nodes[j])==true){
									return true;
								}								
							}else{
								returnFlag = true;
								document.all(nodes[j].name)[n + 1].select();
								document.all(nodes[j].name)[n + 1].focus();
								returnFlag = false;
								Event.stop(event);
								return true;
							}	
						}else{
							if( moveFocus(nodes[j])==true){
								return true;
							}						
						}
					}
				}
				*/												   											
				if( moveFocus(nodes[j])==true){
					return true;
				}
			}
		}
	}
	return false;
}

var key_alt = 18;
var key_tab = 9;
var key_return = 13;
var key_left = 37;
var key_up = 38;
var key_right = 39;
var key_down = 40;

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function isFocusObjs(objType) {
 	switch( objType ){
	case	"text":
	case	"checkbox":
	case	"textarea":
	case	"file":
	case	"button":
	case	"radio":
	case	"password":
	case	"submit":
	case	"select-one":
		return true;
	};
	return false;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function moveCursol(key, activeElement) {
   	var j = 0;
	var nodes = document.forms[0].elements ;
	controlObjs =[];
	for (var i = 0; i < nodes.length; i++){
		if (isFocusObjs(nodes[i].type) == false) {
			continue;
		}
		if (nodes[i].disabled == true || nodes[i].readOnly == true) {
			continue;
		}		
		if( nodes[i].name!=""){
			if (isFocusObjs(nodes[i].type)) {
				controlObjs[j] = nodes[i];
				j++;
			}
		}		
	}		
	for (var i = 0; i < controlObjs.length; i++) {
		if (controlObjs[i] == activeElement) {
			if(i <= 0){
				if (key == "PgDn") {
					controlObjs[i + 1].focus();
				}else{
					controlObjs[controlObjs.length - 1].focus();
				}		
			}else if(i >= (controlObjs.length-1)){
				if (key == "PgUp") {
					controlObjs[i-1].focus();
				}else{
					controlObjs[0].focus();
				}
			}else{
				if(key == "PgUp"){
					controlObjs[i-1].focus();
				}else{
					controlObjs[i+1].focus();
				}
			}
			return true;
		}
	}
	return false;	
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function setInitialFocus(focusName){
	initialFocus = focusName;
	return true;
}

///////////////////////////////////////////////////////
// lҏW̃\bh		
///////////////////////////////////////////////////////
	function isNumFormat(formatType){
	 	switch( formatType ){
		case	"number":
		case	"comma":
		case	"fillzero":
		case	"money":
		case	"decimal":
			return true;
		};
		return false;		
	}

///////////////////////////////////////////////////////
// G[̃\bh
///////////////////////////////////////////////////////
	function alertError(activeElement,detailMsg,errorCountFlag){
		Field.activate(activeElement);
		activeElement.style.backgroundColor = focusColor;
		$(activeElement).style.textAlign = "left";
		if(errorCount == 0){
			alert("** ̓G[ **@@@@@@@@@@@@@@@@@@@@@ \n\n" + detailMsg);
		}
		if(errorCountFlag == true){
			errorCount++;
		}		
	}
///////////////////////////////////////////////////////
// map쐬̃\bh
///////////////////////////////////////////////////////
function createMap(map,base,cursorNum,counter,value){
	for(m in map){
		if(m == cursorNum){
			cursorNum = base + "_" + counter;
			counter += 1;
		}
	}
	map[cursorNum] = value;
	return map;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function createFocusMap(flg, nodes, map,base,cursorNum,counter,value){

	if(nodes.type == "select-one"){

		if(flg == true){
			for (var k = 0;k < document.all(nodes.name).length;k++) {
				value = document.all(nodes.name)[k];
				map = createMap(map, base, cursorNum, counter, value);
				typeMap = createMap(typeMap, base, cursorNum, counter, nodes);
			}
		}else{
			for (var k = document.all(nodes.name).length - 1;k >= 0;k--) {
				value = document.all(nodes.name)[k];
				map = createMap(map, base, cursorNum, counter, value);
				typeMap = createMap(typeMap, base, cursorNum, counter, nodes);
			}
		}
	}else{
		map = createMap(map, base, cursorNum, counter, value);
		typeMap = createMap(typeMap, base, cursorNum, counter, nodes);
	}
	return typeMap;
}



var rDate;
var checkDate
///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function DateCheck(date,mode){

	var errmsg ="tsł";  // 2010/08/13 nakahara modify
	var now = new Date();
	var year = "" + now.getYear(); // N
	if(year < 2000) { 
		year = "" + (eval(year) + 1900);
	}
// "-","/"ŋ؂ĂƂ

	var monthFlag = false;
	if(mode == 11 || mode == 12){
		monthFlag = true;
	}
	rDate = wareki_to_seireki(date,monthFlag);
	hiduke = rDate.replace(/-/g,"/")
	if (! hiduke.match(/^\d{2,4}\/\d{1,2}\/\d{1,2}$/)
	&&	! hiduke.match(/^\d\d\d\d\d\d\d\d$/)){
		var hidukeDate = new Array();
		hidukeDate = hiduke.split("/");
		hiduke = year.substring(0,2) + "" + hidukeDate[2] + "/" + getMonthFromEnglish(hidukeDate[1]) + "/" + hidukeDate[0];
	}

	if (! hiduke.match(/^\d{2,4}\/\d{1,2}\/\d{1,2}$/)
	&&	! hiduke.match(/^\d\d\d\d\d\d\d\d$/)){
  		dateErrorMessage += errmsg;
		return false
	}
//zɔNi[
	checkDate = new Array();
	if (hiduke.match(/^\d{2,4}\/\d{1,2}\/\d{1,2}$/)){
		checkDate = hiduke.split("/")
	}else{
		checkDate[0] = rDate.substring(0,4)
		checkDate[1] = rDate.substring(4,6)
		checkDate[2] = rDate.substring(6,8)
	}
	
	
	if(checkDate[0].length == 2){
		checkDate[0] = year.substring(0,2) + "" + checkDate[0];
	}


	if(isNum(checkDate[0]) == false || isNum(checkDate[1]) == false || isNum(checkDate[2]) == false){
  		dateErrorMessage += errmsg;
		return false;
	}

//̃`FbN
	if (checkDate[1]*1 > 12 || checkDate[1]*1 < 1){
  		dateErrorMessage += errmsg;
		return false
	}
//̃`FbN
//RP܂ł̂Ƃ
	if (checkDate[1]*1 == 1 || checkDate[1]*1 == 3 || checkDate[1]*1 == 5 || checkDate[1]*1 == 7 || checkDate[1]*1 == 8 || checkDate[1]*1 == 10 || checkDate[1]*1 == 12){
		if (checkDate[2]*1 > 31 || checkDate[2]*1 < 1){
	  		dateErrorMessage += errmsg;
			return false
		}
	}else{
//2̃`FbN
		if (checkDate[1]*1 == 2){
			if (checkDate[0] % 4 == 0){
				if (checkDate[2]*1 > 29 || checkDate[2]*1 < 1){
			  		dateErrorMessage += errmsg;
					return false
				}
			}else{
				if (checkDate[2]*1 > 28 || checkDate[2]*1 < 1){
					dateErrorMessage += errmsg;
					return false
				}
			}
		}else{
//RÕ`FbN
			if (checkDate[2]*1 > 30 || checkDate[2]*1 < 1){
		  		dateErrorMessage += errmsg;
				return false
			}
		}
	}
	
	if(mode == 1){
		if(checkDate[1].length == 1){
			checkDate[1] = "0" + checkDate[1];
		}
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[0] + "/" + checkDate[1] + "/" + checkDate[2];
	}
	if(mode == 2){
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = checkDate[0] + "/" + checkDate[1] + "/" + checkDate[2];
	}
	if(mode == 3){
		var nengou_year = checkDate[0];
		if(checkDate[0] >= 1988){
			nengou_year = "H" + (checkDate[0] - 1988);
		}else if(checkDate[0] >= 1925){
			nengou_year = "S" + (checkDate[0] - 1925);
		}else if(checkDate[0] >= 1911){
		   	nengou_year = "T" + (checkDate[0] - 1911);
		}else if(checkDate[0] >= 1876){
			nengou_year = "M" + (checkDate[0] - 1876);
		}
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = nengou_year + "N" + checkDate[1] + "" + checkDate[2] + "";
	}
	if(mode == 4){
		var nengou_year = checkDate[0];
		if(checkDate[0] >= 1988){
			nengou_year = "" + (checkDate[0] - 1988);
		}else if(checkDate[0] >= 1925){
			nengou_year = "a" + (checkDate[0] - 1925);
		}else if(checkDate[0] >= 1911){
		   	nengou_year = "吳" + (checkDate[0] - 1911);
		}else if(checkDate[0] >= 1876){
			nengou_year = "" + (checkDate[0] - 1876);
		}
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = nengou_year + "N" + checkDate[1] + "" + checkDate[2] + "";
	}  
	if(mode == 5){
		if(checkDate[1].length == 1){
			checkDate[1] = "0" + checkDate[1];
		}
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[0].substring(2,4) + "/" + checkDate[1] + "/" + checkDate[2];
	}
	if(mode == 6){
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = checkDate[0].substring(2,4) + "/" + checkDate[1] + "/" + checkDate[2];
	}
	if(mode == 7){
		checkDate[1] = eval(checkDate[1]);
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[2] + "-" + getEnglishMonth(checkDate[1]) + "-" + checkDate[0].substring(2,4);
	}
	if(mode == 8){
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = checkDate[2] + "-" + getEnglishMonth(checkDate[1]) + "-" + checkDate[0].substring(2,4);
	}	   
	if(mode == 9){
		if(checkDate[1].length == 1){
			checkDate[1] = "0" + checkDate[1];
		}
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[0] + "N" + checkDate[1] + "" + checkDate[2] + "";
	}
	if(mode == 10){
		checkDate[1] = eval(checkDate[1]);
		checkDate[2] = eval(checkDate[2]);
		rDate = checkDate[0] + "N" + checkDate[1] + "" + checkDate[2] + "";
	}	
	if(mode == 11){
		if(checkDate[1].length == 1){
			checkDate[1] = "0" + checkDate[1];
		}
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[0] + "/" + checkDate[1];
	}		   
	if(mode == 12){
		if(checkDate[1].length == 1){
			checkDate[1] = "0" + checkDate[1];
		}
		if(checkDate[2].length == 1){
			checkDate[2] = "0" + checkDate[2];
		}
		rDate = checkDate[0] + "N" + checkDate[1] + "";
	}				  
	return true
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function wareki_to_seireki(date,monthFlag){
	var str = "";
	var index = 0;
	var warekiFlag = false;
	var mode;
	for(var i = 0; i < date.length ; i++){
		if(i == 0){
			if(date.charAt(i) == "H" || date.charAt(i) == "S" || date.charAt(i) == "M" || date.charAt(i) == "T"){
				mode = 3;
			}else if(date.charAt(i) == "" || date.charAt(i) == "" || date.charAt(i) == "" || date.charAt(i) == ""){
				mode = 4;
			}
		}
		if(date.charAt(i) == "N" || date.charAt(i) == "" || date.charAt(i) == "" ){
			str += date.substring(index,i) + "/";
			index = i + 1;
			var warekiFlag = true;
		}
	}
	str = str.substring(0,str.length - 1);
	if(str.length == 0){
		str = date;
	}
	
	if(monthFlag == true){
		str += "/01";
	}
	
	if(mode == 3 && warekiFlag == true){
		if (! str.substring(1).match(/^\d{1,2}\/\d{1,2}\/\d{1,2}$/)){
			return str;
		}
		var m = str.charAt(0).toUpperCase();
		var y = eval(str.substring(1,str.indexOf("/")));
		var md = str.substring(str.indexOf("/"));
		if ((m == "H") && (y > 0) && (y < 50)){
			return (1988 + y) + "" + md;
		}
		if ((m == "S") && (y > 0) && (y < 65)){
			return (1925 + y )+ "" + md;
		}
		if ((m == "T") && (y > 0) && (y < 16)){
			return (1911 + y )+ "" + md;
		}
		if ((m == "M") && (y > 0) && (y < 46)){
			return (1867 + y )+ "" + md;
		}
	}
	if(mode == 4 && warekiFlag == true){
		if (! str.substring(2).match(/^\d{1,2}\/\d{1,2}\/\d{1,2}$/)){
			return str;
		}	
		var m2 = str.substring(0,2);
		str = str.substring(2);
		var y2 = eval(str.substring(0,str.indexOf("/")));
		var md2 = str.substring(str.indexOf("/"));
		if ((m2 == "") && (y2 > 0) && (y2 < 50)){
			return (1988 + y2 )+ "" + md2;
		}
		if ((m2 == "a") && (y2 > 0) && (y2 < 65)){
			return (1925 + y2 )+ "" + md2;
		}
		if ((m2 == "吳") && (y2 > 0) && (y2 < 16)){
			return (1911 + y2 )+ "" + md2;
		}
		if ((m2 == "") && (y2 > 0) && (y2 < 46)){
			return (1867 + y2 )+ "" + md2;
		}
	}
	return str;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function getEnglishMonth(monthNum){
	var str = monthNum;
	if(monthNum == 1){
		str = "Jan";
	}else if(monthNum == 2){
		str = "Feb";
	}else if(monthNum == 3){
		str = "Mar";
	}else if(monthNum == 4){
		str = "Apr";
	}else if(monthNum == 5){
		str = "May";
	}else if(monthNum == 6){
		str = "Jun";
	}else if(monthNum == 7){
		str = "Jul";
	}else if(monthNum == 8){
		str = "Aug";
	}else if(monthNum == 9){
		str = "Sep";
	}else if(monthNum == 10){
		str = "Oct";
	}else if(monthNum == 11){
		str = "Nov";
	}else if(monthNum == 12){
		str = "Dec";
	}
	return str;
}

///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function getMonthFromEnglish(month){
	var str = month;
	if(month == "Jan"){
		str = "01";
	}else if(month == "Feb"){
		str = "02";
	}else if(month == "Mar"){
		str = "03";
	}else if(month == "Apr"){
		str = "04";
	}else if(month == "May"){
		str = "05";
	}else if(month == "Jun"){
		str = "06";
	}else if(month == "Jul"){
		str = "07";
	}else if(month == "Aug"){
		str = "08";
	}else if(month == "Sep"){
		str = "09";
	}else if(month == "Oct"){
		str = "10";
	}else if(month == "Nov"){
		str = "11";
	}else if(month == "Dec"){
		str = "12";
	}
	return str;
}


///////////////////////////////////////////////////////
//	
///////////////////////////////////////////////////////
function errClear(){

	var objs = document.getElementsByTagName('div');
	for(var i = 0; i < objs.length; i++) {
		if(objs[i].className == "err"){
			objs[i].innerHTML  = "";
			break;
		}
		
	}
	return true;
}

// -->
//</script>
	
////////////////////////////////////////////////////////////////
// Copyright(C)2010 OrientalArts Corporation All Rights Reserved.










































